#pragma region Copyright 2012 IPETRONIK GmbH & Co.KG
//
// All rights are reserved. Reproduction or transmission in whole or in part, in
// any form or by any means, electronic, mechanical or otherwise, is prohibited
// without the prior written consent of the copyright owner.
//
// KGI
//
#pragma endregion
/// <summary>
/// Extension.h
/// </summary>

#pragma once

///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
/// <summary>
/// ATTENTION
/// ATTENTION DO NOT MODIFY THIS FILE BY HAND!
/// ATTENTION
/// </summary>
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////
/// <summary>
/// Global member: Dll related data (defined in Serial.Acquisition.Extension.cpp)
/// </summary>
extern BOOL g_bIsDiagnosticsVersion;

///////////////////////////////////////////////////////////////////////////////////////////
/// <summary>
/// Function indicating that additional messages are to be logged (if any)
/// </summary>
bool IsDiagnosticsVersion();

///////////////////////////////////////////////////////////////////////////////////////////
/// <summary>
/// setting variable determining version type
/// </summary>
HRESULT DoSetDiagnosticsVersion(BOOL isDiagnosticsVersion);

///////////////////////////////////////////////////////////////////////////////////////////
/// <summary>
/// setting some general callbacks
/// </summary>
HRESULT DoSetCallbacks(	PFN_EXT_SET_PACKET_DATA_FLOAT64_FUNC pfnDataFloat64,
                        PFN_EXT_SEND_DATA_FUNC               pfnSendData,
                        PFN_EXT_READ_INPUT_BUFFER            pfnReadInputBuffer,
                        PFN_EXT_RESET_INPUT_BUFFER           pfnResetInputBuffer,
                        PFN_EXT_TRACE_MESSAGE                pfnTraceInformation,
                        PFN_EXT_TRACE_MESSAGE                pfnTraceWarning,
                        PFN_EXT_TRACE_MESSAGE                pfnTraceError);

///////////////////////////////////////////////////////////////////////////////////////////
/// <summary>
/// Get the active flag of the given structure
/// </summary>
HRESULT GetActive(TSystemParameter *pParameter, BOOL *pbActive);

///////////////////////////////////////////////////////////////////////////////////////////
/// <summary>
/// Get the active flag of the given structure
/// </summary>
HRESULT GetIdentifier(TSystemParameter *pParameter, ULONG *pulIdentifier);

///////////////////////////////////////////////////////////////////////////////////////////
/// <summary>
/// Get the active flag of the given structure
/// </summary>
HRESULT GetActive(TPacketParameter *pParameter, BOOL *pbActive);

///////////////////////////////////////////////////////////////////////////////////////////
/// <summary>
/// Get the active flag of the given structure
/// </summary>
HRESULT GetIdentifier(TPacketParameter *pParameter, ULONG *pulIdentifier);
