#pragma region Copyright 2012 IPETRONIK GmbH & Co.KG
//
// All rights are reserved. Reproduction or transmission in whole or in part, in
// any form or by any means, electronic, mechanical or otherwise, is prohibited
// without the prior written consent of the copyright owner.
//
// 
//
#pragma endregion

/// <summary>
/// Extension.cpp : Definiert den Einstiegspunkt für die DLL-Anwendung.
/// </summary>
#include "Extension.h"

/// <summary>
/// Global member: Dll related data
/// </summary>
HINSTANCE	g_hResource         = NULL;

UINT16		g_usVersionMajor    = 0;
UINT16		g_usVersionMinor    = 0;
UINT16		g_usVersionRevision = 0;
UINT16		g_usVersionBuild    = 0;

/// <summary>
/// Entry point
/// </summary>
BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	WCHAR				wszPathName[20000];
	ULONG				ulLen, ulDummy;
	BYTE*				pVersionInfo;
	LPVOID				lpvi;
	UINT				iLen;
	VS_FIXEDFILEINFO	FileInfo;

	if (ul_reason_for_call == DLL_PROCESS_ATTACH)
	{
#if defined(ACTIVATE_MEMORY_LEAK_DETECTION)
		//
		// Activate memory leak detection - additional modification in main header file needed (see Extension.h)
		//
		// source: http://msdn.microsoft.com/en-us/library/x98tx3cf.aspx
		//
		// Additional info: for setting a break point on the allocation number (displayed
		// in curly brackets in the debug output), the following method has to be implemented:
		//    _CrtSetBreakAlloc(xyz);
		// with xyz the allocation number.
		//
		int flag = _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG); // Get current flag

		flag |= _CRTDBG_LEAK_CHECK_DF; // Turn on leak-checking bit
		flag |= _CRTDBG_ALLOC_MEM_DF;  // call _CrtDumpMemoryLeaks() on program exit

		_CrtSetDbgFlag(flag); // Set flag to the new value
#endif

		// save module handle for resource loading
		g_hResource = hModule;

		// version number for trace purpose
		if (::GetModuleFileName(hModule, wszPathName, 20000) > 0)
		{	
			if ((ulLen = ::GetFileVersionInfoSize((LPTSTR)wszPathName, &ulDummy)) > 0)
			{
				pVersionInfo = new BYTE[ulLen];
				if (pVersionInfo)
				{	
					if (::GetFileVersionInfo((LPTSTR)wszPathName, 0, ulLen, pVersionInfo))
					{
						if (::VerQueryValue(pVersionInfo, TEXT("\\"), &lpvi, &iLen))
						{
							FileInfo = *(VS_FIXEDFILEINFO*)lpvi;

							g_usVersionMajor    = HIWORD(FileInfo.dwProductVersionMS);
							g_usVersionMinor    = LOWORD(FileInfo.dwProductVersionMS);
							g_usVersionRevision = (UINT16)((FileInfo.dwProductVersionLS & 0xFFFF0000) >> 16);
							g_usVersionBuild    = (UINT16)(FileInfo.dwProductVersionLS & 0xFFFF);
						}
					}
					delete [] pVersionInfo;
				}
			}
		}
	}
	return TRUE;
}
